float hash(float n){
return frac(sin(n)*43758.5453);
}

float dithering(float3 x){
    float3 p = floor(x);
    float n = p.x + p.y * 157.0 + p.z * 113.0;
return hash(n);
}

float Noise(float2 x){
	float2 p = floor(x);
	float2 f = frac(x);
        f = f*f*(3.0-2.0*f);

    float n = p.x + p.y*57.0;
return lerp(lerp( hash(n+  0.0), hash(n+  1.0),f.x), lerp( hash(n+ 57.0), hash(n+ 58.0),f.x),f.y);
}

float Noise(float3 x){
    float3 p = floor(x);
    float3 f = frac(x);
    f = f*f*(3.0-2.0*f);
	
    float n = p.x + p.y*157.0 + 113.0*p.z;
return lerp(lerp(lerp( hash(n+  0.0), hash(n+  1.0),f.x),
                   lerp( hash(n+157.0), hash(n+158.0),f.x),f.y),
               lerp(lerp( hash(n+113.0), hash(n+114.0),f.x),
                   lerp( hash(n+270.0), hash(n+271.0),f.x),f.y),f.z);
}

// traditional fractal brownian
float fbm(float2 p){
float f = 0.0;
	f += 0.25*Noise( p ); p = p*2.03;
	f += 0.12*Noise( p ); p = p*2.04;
return f;
}