highp float hash( highp float n ){
return fract(sin(n)*43758.5453);
}

highp float dithering(highp vec3 x){
    highp vec3 p = floor(x);
    highp float n = p.x + p.y * 157.0 + p.z * 113.0;
return hash(n);
}

highp float noise( highp vec2 x ){
	highp vec2 p = floor(x);
	highp vec2 f = fract(x);
    f = f*f*(3.0-2.0*f);

    highp float n = p.x + p.y*57.0;
return mix(mix( hash(n+  0.0), hash(n+  1.0),f.x), mix( hash(n+ 57.0), hash(n+ 58.0),f.x),f.y);
}

highp float noise( highp vec3 x ){
    highp vec3 p = floor(x);
    highp vec3 f = fract(x);
    f = f*f*(3.0-2.0*f);
	
    highp float n = p.x + p.y*157.0 + 113.0*p.z;
return mix(mix(mix( hash(n+  0.0), hash(n+  1.0),f.x),
                   mix( hash(n+157.0), hash(n+158.0),f.x),f.y),
               mix(mix( hash(n+113.0), hash(n+114.0),f.x),
                   mix( hash(n+270.0), hash(n+271.0),f.x),f.y),f.z);
}

// traditional fractal brownian for reflect water
highp float fbm(highp vec2 p){
highp float f = 0.0;
	f += 0.25*noise( p ); p = p*2.03;
	f += 0.12*noise( p ); p = p*2.04;
return f*0.7;
}










































