#include "ShaderConstants.fxh"

struct PS_Input
{
	float4 position : SV_Position;
	float4 color : COLOR;
	float3 pos : POS;
};

struct PS_Output
{
	float4 color : SV_Target;
};

/////////////////////////////////////////////////////////////////
///////////////////////// STOP! /////////////////////////////////
// Made by @bicubic7
// Don't steal anything!
// Don't use code without permit!
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

float3 skycolor(float lenpos){
	float2 ftime = float2(pow(max(min(1.0-FOG_COLOR.r*1.5,1.),.0),1.2),pow(max(min(1.0-FOG_COLOR.r*1.2,1.),.0),.5));
	float dark= (1.-FOG_COLOR.b)*clamp((FOG_COLOR.r-.15)*1.2,0.,1.);

	float3 skycolor = lerp(float3(.0,.35,.8),float3(.2,.4,.9)*.34,ftime.x);
		skycolor = lerp(skycolor,float3(0,0.2,0.6),dark);
		skycolor = lerp(skycolor,FOG_COLOR.rgb*1.5,1.-pow(FOG_CONTROL.y,10.0));

	float3 scattercolor = lerp(FOG_COLOR.rgb,FOG_COLOR.rgb*1.2+float3(FOG_COLOR.r,FOG_COLOR.g,FOG_COLOR.b*2.)*1.2,min(dark*ftime.y*3.,1.));
		scattercolor = lerp(scattercolor,FOG_COLOR.rgb*1.3,1.-pow(FOG_CONTROL.y,10));

if(FOG_CONTROL.x == 0.){
return FOG_COLOR.rgb;
} else {
return lerp(skycolor,scattercolor,smoothstep(0.,1.,pow(lenpos,1.)));
}
}

ROOT_SIGNATURE
void main(in PS_Input PSInput, out PS_Output PSOutput)
{
	float lp = length(PSInput.pos.xz);
	float3 sky = skycolor(lp);
	PSOutput.color = float4(sky,FOG_COLOR.a);
}